To set the filter for a sheet, first create a row filter, then use the rowFilter method to set the row filter.
You can also create a condition and use the addFilterItem method to add a specified filter to the row filter. For example:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
const spreadNS = GC.Spread.Sheets;
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setRowCount(50);
sheet.setColumnCount(8);
let rc = sheet.getRowCount();
let cc = sheet.getColumnCount();
for (let r = 0; r < rc; r++) {
for (let c = 0; c < cc; c++) {
if (c == 0) {
sheet.setValue(r, c, "Value is Number");
} else {
sheet.setValue(r, c, r + c);
}
}
}
sheet.setValue(0, 0, "Conditions", spreadNS.SheetArea.colHeader);
sheet.setValue(0, 1, "Cell Value", spreadNS.SheetArea.colHeader);
sheet.setValue(1, 0, "Text contains e");
sheet.setValue(10, 0, "Text doesn't contains e");
sheet.setValue(21, 0, "Text contains e");
sheet.setValue(1, 1, "begin");
sheet.setValue(10, 1, "during");
sheet.setValue(21, 1, "end");
sheet.setValue(2, 0, "Background is Cyan");
sheet.setValue(6, 0, "Background is Purple");
sheet.setValue(12, 0, "Background is Cyan");
sheet.getCell(2, 1).backColor("Cyan");
sheet.getCell(6, 1).backColor("Purple");
sheet.getCell(12, 1).backColor("Cyan");
sheet.setValue(3, 0, "Value is Thursday");
sheet.setValue(8, 0, "Value is Friday");
sheet.setValue(14, 0, "Value is Thursday");
sheet.setValue(3, 1, new Date(2011, 5, 30));
sheet.setValue(8, 1, new Date(2011, 6, 1));
sheet.setValue(14, 1, new Date(2011, 5, 30));
sheet.setValue(4, 0, "Value is null");
sheet.setValue(9, 0, "Value is null");
sheet.setValue(18, 0, "Value is null");
sheet.setValue(4, 1, null);
sheet.setValue(9, 1, null);
sheet.setValue(18, 1, null);
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(1, 150);
let filter = new spreadNS.Filter.HideRowFilter(new spreadNS.Range(-1, 0, -1, 2));
sheet.rowFilter(filter);
filter.filterButtonVisible(false);
sheet.resumePaint();
}
doFilter(type: string) {
let sheet = this.spread.getActiveSheet();
let filter = sheet.rowFilter();
if (filter) {
filter.removeFilterItems(1);
if (type !== "none") {
let condition = this.getCondition(type);
filter.addFilterItem(1, condition);
}
filter.filter(1);
sheet.invalidateLayout();
sheet.repaint();
}
}
getCondition(type: string) {
switch(type) {
case "text":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.textCondition, {
compareType: spreadNS.ConditionalFormatting.TextCompareType.contains,
expected: "*e*"
});
case "number":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.numberCondition, {
compareType: spreadNS.ConditionalFormatting.GeneralComparisonOperators.lessThan,
expected: 20
});
case "date":
return new spreadNS.ConditionalFormatting.Condition.fromWeek(4);
case "style":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.colorCondition, {
compareType: spreadNS.ConditionalFormatting.ColorCompareType.backgroundColor,
expected: "Cyan"
});
case "custom":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.formulaCondition, {
customValueType: spreadNS.ConditionalFormatting.CustomValueType.empty,
formula: null
});
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<label >These condition rules filter apply to Column2</label>
<hr>
<div class="option-row">
<input type="radio" name="filter_condition" id="none_condition" checked (click)="doFilter('none')" />
<label for="none_condition">No Filter</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="text_condition" (click)="doFilter('text')" />
<label for="text_condition" style="display: inline-block; width: 210px;">Text Condition(Contains e)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="number_condition" (click)="doFilter('number')" />
<label for="number_condition">Number Condition(less than 20)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="date_condition" (click)="doFilter('date')" />
<label for="date_condition" id="label_date_condition" style="display: inline-block; width: 210px;">Date Condition (is Thursday)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="style_condition" (click)="doFilter('style')" />
<label for="style_condition">Style Condition(Cyan background)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="custom_condition" (click)="doFilter('custom')" />
<label for="custom_condition" id="label_custom_condition">Customize Condition(Value is empty)</label>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 3px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.2.2-master-2026-09-02-2133/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

To set the filter for a sheet, first create a row filter, then use the rowFilter method to set the row filter.
You can also create a condition and use the addFilterItem method to add a specified filter to the row filter. For example:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<label>These condition rules filter apply to Column2</label>
<hr>
<div class="option-row">
<input type="radio" name="filter_condition" id="none_condition" checked @click="doFilter('none')" />
<label for="none_condition">No Filter</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="text_condition" @click="doFilter('text')" />
<label for="text_condition" style="display: inline-block; width: 210px;">Text Condition(Contains e)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="number_condition" @click="doFilter('number')" />
<label for="number_condition">Number Condition(less than 20)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="date_condition" @click="doFilter('date')" />
<label for="date_condition" id="label_date_condition" style="display: inline-block; width: 210px;">Date
Condition (is Thursday)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="style_condition" @click="doFilter('style')" />
<label for="style_condition">Style Condition(Cyan background)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="custom_condition" @click="doFilter('custom')" />
<label for="custom_condition" id="label_custom_condition">Customize Condition(Value is empty)</label>
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue';
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
const spreadRef = ref(null);
const spreadNS = GC.Spread.Sheets;
const initSpread = (spread) => {
spreadRef.value = spread;
var sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setRowCount(50);
sheet.setColumnCount(8);
var rc = sheet.getRowCount();
var cc = sheet.getColumnCount();
for (var r = 0; r < rc; r++) {
for (var c = 0; c < cc; c++) {
if (c == 0) {
sheet.setValue(r, c, "Value is Number");
} else {
sheet.setValue(r, c, r + c);
}
}
}
sheet.setValue(0, 0, "Conditions", spreadNS.SheetArea.colHeader);
sheet.setValue(0, 1, "Cell Value", spreadNS.SheetArea.colHeader);
sheet.setValue(1, 0, "Text contains e");
sheet.setValue(10, 0, "Text doesn't contains e");
sheet.setValue(21, 0, "Text contains e");
sheet.setValue(1, 1, "begin");
sheet.setValue(10, 1, "during");
sheet.setValue(21, 1, "end");
sheet.setValue(2, 0, "Background is Cyan");
sheet.setValue(6, 0, "Background is Purple");
sheet.setValue(12, 0, "Background is Cyan");
sheet.getCell(2, 1).backColor("Cyan");
sheet.getCell(6, 1).backColor("Purple");
sheet.getCell(12, 1).backColor("Cyan");
sheet.setValue(3, 0, "Value is Thursday");
sheet.setValue(8, 0, "Value is Friday");
sheet.setValue(14, 0, "Value is Thursday");
sheet.setValue(3, 1, new Date(2011, 5, 30));
sheet.setValue(8, 1, new Date(2011, 6, 1));
sheet.setValue(14, 1, new Date(2011, 5, 30));
sheet.setValue(4, 0, "Value is null");
sheet.setValue(9, 0, "Value is null");
sheet.setValue(18, 0, "Value is null");
sheet.setValue(4, 1, null);
sheet.setValue(9, 1, null);
sheet.setValue(18, 1, null);
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(1, 150);
var filter = new spreadNS.Filter.HideRowFilter(new spreadNS.Range(-1, 0, -1, 2));
sheet.rowFilter(filter);
filter.filterButtonVisible(false);
sheet.resumePaint();
}
const doFilter = (type) => {
var sheet = spreadRef.value.getActiveSheet();
var filter = sheet.rowFilter();
if (filter) {
filter.removeFilterItems(1);
if (type !== "none") {
var condition = getCondition(type);
filter.addFilterItem(1, condition);
}
filter.filter(1);
sheet.invalidateLayout();
sheet.repaint();
}
}
const getCondition = (type) => {
switch (type) {
case "text":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.textCondition, {
compareType: spreadNS.ConditionalFormatting.TextCompareType.contains,
expected: "*e*"
});
case "number":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.numberCondition, {
compareType: spreadNS.ConditionalFormatting.GeneralComparisonOperators.lessThan,
expected: 20
});
case "date":
return new spreadNS.ConditionalFormatting.Condition.fromWeek(4);
case "style":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.colorCondition, {
compareType: spreadNS.ConditionalFormatting.ColorCompareType.backgroundColor,
expected: "Cyan"
});
case "custom":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.formulaCondition, {
customValueType: spreadNS.ConditionalFormatting.CustomValueType.empty,
formula: null
});
}
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 3px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.2.2-master-2026-09-02-2133/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

To set the filter for a sheet, first create a row filter, then use the rowFilter method to set the row filter.
You can also create a condition and use the addFilterItem method to add a specified filter to the row filter. For example:
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
const spreadNS = GC.Spread.Sheets;
function _getElementById(id) {
return document.getElementById(id);
}
export function AppFunc() {
let spread = null;
let initSpread = function(value) {
spread = value;
var sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setRowCount(50);
sheet.setColumnCount(8);
var rc = sheet.getRowCount();
var cc = sheet.getColumnCount();
for (var r = 0; r < rc; r++) {
for (var c = 0; c < cc; c++) {
if (c == 0) {
sheet.setValue(r, c, "Value is Number");
} else {
sheet.setValue(r, c, r + c);
}
}
}
sheet.setValue(0, 0, "Conditions", spreadNS.SheetArea.colHeader);
sheet.setValue(0, 1, "Cell Value", spreadNS.SheetArea.colHeader);
sheet.setValue(1, 0, "Text contains e");
sheet.setValue(10, 0, "Text doesn't contains e");
sheet.setValue(21, 0, "Text contains e");
sheet.setValue(1, 1, "begin");
sheet.setValue(10, 1, "during");
sheet.setValue(21, 1, "end");
sheet.setValue(2, 0, "Background is Cyan");
sheet.setValue(6, 0, "Background is Purple");
sheet.setValue(12, 0, "Background is Cyan");
sheet.getCell(2, 1).backColor("Cyan");
sheet.getCell(6, 1).backColor("Purple");
sheet.getCell(12, 1).backColor("Cyan");
sheet.setValue(3, 0, "Value is Thursday");
sheet.setValue(8, 0, "Value is Friday");
sheet.setValue(14, 0, "Value is Thursday");
sheet.setValue(3, 1, new Date(2011, 5, 30));
sheet.setValue(8, 1, new Date(2011, 6, 1));
sheet.setValue(14, 1, new Date(2011, 5, 30));
sheet.setValue(4, 0, "Value is null");
sheet.setValue(9, 0, "Value is null");
sheet.setValue(18, 0, "Value is null");
sheet.setValue(4, 1, null);
sheet.setValue(9, 1, null);
sheet.setValue(18, 1, null);
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(1, 150);
var filter = new spreadNS.Filter.HideRowFilter(new spreadNS.Range(-1, 0, -1, 2));
sheet.rowFilter(filter);
filter.filterButtonVisible(false);
sheet.resumePaint();
}
let doFilter = function(type) {
var sheet = spread.getActiveSheet();
var filter = sheet.rowFilter();
if (filter) {
filter.removeFilterItems(1);
if (type !== "none") {
var condition = getCondition(type);
filter.addFilterItem(1, condition);
}
filter.filter(1);
sheet.invalidateLayout();
sheet.repaint();
}
}
let getCondition = function(type) {
switch(type) {
case "text":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.textCondition, {
compareType: spreadNS.ConditionalFormatting.TextCompareType.contains,
expected: "*e*"
});
case "number":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.numberCondition, {
compareType: spreadNS.ConditionalFormatting.GeneralComparisonOperators.lessThan,
expected: 20
});
case "date":
return new spreadNS.ConditionalFormatting.Condition.fromWeek(4);
case "style":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.colorCondition, {
compareType: spreadNS.ConditionalFormatting.ColorCompareType.backgroundColor,
expected: "Cyan"
});
case "custom":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.formulaCondition, {
customValueType: spreadNS.ConditionalFormatting.CustomValueType.empty,
formula: null
});
}
}
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel doFilter={(type)=>{doFilter(type)}} />
</div>);
}
class Panel extends Component{
constructor(props){
super(props);
}
render(){
return(
<div class="options-container">
<label >These condition rules filter apply to Column2</label>
<hr />
<div class="option-row">
<input type="radio" name="filter_condition" id="none_condition" defaultChecked onClick={()=>{this.props.doFilter("none")}} />
<label htmlFor="none_condition">No Filter</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="text_condition" onClick={()=>{this.props.doFilter("text")}} />
<label htmlFor="text_condition" style={{display: "inline-block", width: "210px"}}>Text Condition(Contains e)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="number_condition" onClick={()=>{this.props.doFilter("number")}} />
<label htmlFor="number_condition">Number Condition(less than 20)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="date_condition" onClick={()=>{this.props.doFilter("date")}} />
<label htmlFor="date_condition" id="label_date_condition" style={{display: "inline-block", width: "210px"}}>Date Condition (is Thursday)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="style_condition" onClick={()=>{this.props.doFilter("style")}} />
<label htmlFor="style_condition">Style Condition(Cyan background)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="custom_condition" onClick={()=>{this.props.doFilter("custom")}} />
<label htmlFor="custom_condition" id="label_custom_condition">Customize Condition(Value is empty)</label>
</div>
</div>
)
}
}
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
const spreadNS = GC.Spread.Sheets;
function _getElementById(id) {
return document.getElementById(id);
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
}
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel doFilter={(type)=>{this.doFilter(type)}} />
</div>;
}
initSpread(spread) {
this.spread = spread;
var sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setRowCount(50);
sheet.setColumnCount(8);
var rc = sheet.getRowCount();
var cc = sheet.getColumnCount();
for (var r = 0; r < rc; r++) {
for (var c = 0; c < cc; c++) {
if (c == 0) {
sheet.setValue(r, c, "Value is Number");
} else {
sheet.setValue(r, c, r + c);
}
}
}
sheet.setValue(0, 0, "Conditions", spreadNS.SheetArea.colHeader);
sheet.setValue(0, 1, "Cell Value", spreadNS.SheetArea.colHeader);
sheet.setValue(1, 0, "Text contains e");
sheet.setValue(10, 0, "Text doesn't contains e");
sheet.setValue(21, 0, "Text contains e");
sheet.setValue(1, 1, "begin");
sheet.setValue(10, 1, "during");
sheet.setValue(21, 1, "end");
sheet.setValue(2, 0, "Background is Cyan");
sheet.setValue(6, 0, "Background is Purple");
sheet.setValue(12, 0, "Background is Cyan");
sheet.getCell(2, 1).backColor("Cyan");
sheet.getCell(6, 1).backColor("Purple");
sheet.getCell(12, 1).backColor("Cyan");
sheet.setValue(3, 0, "Value is Thursday");
sheet.setValue(8, 0, "Value is Friday");
sheet.setValue(14, 0, "Value is Thursday");
sheet.setValue(3, 1, new Date(2011, 5, 30));
sheet.setValue(8, 1, new Date(2011, 6, 1));
sheet.setValue(14, 1, new Date(2011, 5, 30));
sheet.setValue(4, 0, "Value is null");
sheet.setValue(9, 0, "Value is null");
sheet.setValue(18, 0, "Value is null");
sheet.setValue(4, 1, null);
sheet.setValue(9, 1, null);
sheet.setValue(18, 1, null);
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(1, 150);
var filter = new spreadNS.Filter.HideRowFilter(new spreadNS.Range(-1, 0, -1, 2));
sheet.rowFilter(filter);
filter.filterButtonVisible(false);
sheet.resumePaint();
}
doFilter(type) {
var sheet = this.spread.getActiveSheet();
var filter = sheet.rowFilter();
if (filter) {
filter.removeFilterItems(1);
if (type !== "none") {
var condition = this.getCondition(type);
filter.addFilterItem(1, condition);
}
filter.filter(1);
sheet.invalidateLayout();
sheet.repaint();
}
}
getCondition(type) {
switch(type) {
case "text":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.textCondition, {
compareType: spreadNS.ConditionalFormatting.TextCompareType.contains,
expected: "*e*"
});
case "number":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.numberCondition, {
compareType: spreadNS.ConditionalFormatting.GeneralComparisonOperators.lessThan,
expected: 20
});
case "date":
return new spreadNS.ConditionalFormatting.Condition.fromWeek(4);
case "style":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.colorCondition, {
compareType: spreadNS.ConditionalFormatting.ColorCompareType.backgroundColor,
expected: "Cyan"
});
case "custom":
return new spreadNS.ConditionalFormatting.Condition(spreadNS.ConditionalFormatting.ConditionType.formulaCondition, {
customValueType: spreadNS.ConditionalFormatting.CustomValueType.empty,
formula: null
});
}
}
}
class Panel extends Component{
constructor(props){
super(props);
}
render(){
return(
<div class="options-container">
<label >These condition rules filter apply to Column2</label>
<hr />
<div class="option-row">
<input type="radio" name="filter_condition" id="none_condition" defaultChecked onClick={()=>{this.props.doFilter("none")}} />
<label htmlFor="none_condition">No Filter</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="text_condition" onClick={()=>{this.props.doFilter("text")}} />
<label htmlFor="text_condition" style={{display: "inline-block", width: "210px"}}>Text Condition(Contains e)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="number_condition" onClick={()=>{this.props.doFilter("number")}} />
<label htmlFor="number_condition">Number Condition(less than 20)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="date_condition" onClick={()=>{this.props.doFilter("date")}} />
<label htmlFor="date_condition" id="label_date_condition" style={{display: "inline-block", width: "210px"}}>Date Condition (is Thursday)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="style_condition" onClick={()=>{this.props.doFilter("style")}} />
<label htmlFor="style_condition">Style Condition(Cyan background)</label>
</div>
<div class="option-row">
<input type="radio" name="filter_condition" id="custom_condition" onClick={()=>{this.props.doFilter("custom")}} />
<label htmlFor="custom_condition" id="label_custom_condition">Customize Condition(Value is empty)</label>
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 3px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.2.2-master-2026-09-02-2133/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);